"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockerHandle = void 0;
const url_1 = __importDefault(require("url"));
const body_parser_1 = __importDefault(require("body-parser"));
const utils_1 = require("./utils");
function mockerHandle(param) {
    const { options = {}, req, res, next, mocker, mockerKey } = param || {};
    let bodyParserMethd = body_parser_1.default.json({ ...options.bodyParserJSON }); // 默认使用json解析
    /**
     * `application/x-www-form-urlencoded; charset=UTF-8` => `application/x-www-form-urlencoded`
     * Issue: https://github.com/jaywcjlove/mocker-api/issues/50
     */
    let contentType = req.get('Content-Type');
    contentType = contentType && contentType.replace(/;.*$/, '');
    if (options.bodyParserConf && options.bodyParserConf[contentType]) {
        // 如果存在options.bodyParserConf配置 {'text/plain': 'text','text/html': 'text'}
        switch (options.bodyParserConf[contentType]) { // 获取bodyParser的方法
            case 'raw':
                bodyParserMethd = body_parser_1.default.raw({ ...options.bodyParserRaw });
                break;
            case 'text':
                bodyParserMethd = body_parser_1.default.text({ ...options.bodyParserText });
                break;
            case 'urlencoded':
                bodyParserMethd = body_parser_1.default.urlencoded({ extended: false, ...options.bodyParserUrlencoded });
                break;
            case 'json': bodyParserMethd = body_parser_1.default.json({ ...options.bodyParserJSON }); //使用json解析 break;
        }
    }
    else {
        // 兼容原来的代码,默认解析
        // Compatible with the original code, default parsing
        switch (contentType) {
            case 'text/plain':
                bodyParserMethd = body_parser_1.default.raw({ ...options.bodyParserRaw });
                break;
            case 'text/html':
                bodyParserMethd = body_parser_1.default.text({ ...options.bodyParserText });
                break;
            case 'application/x-www-form-urlencoded':
                bodyParserMethd = body_parser_1.default.urlencoded({ extended: false, ...options.bodyParserUrlencoded });
                break;
        }
    }
    bodyParserMethd(req, res, function () {
        const result = mocker[mockerKey];
        if (typeof result === 'function') {
            const rgxStr = ~mockerKey.indexOf(' ') ? ' ' : '';
            req.params = (0, utils_1.pathMatch)({ sensitive: false, strict: false, end: false })(mockerKey.split(new RegExp(rgxStr))[1])(url_1.default.parse(req.url).pathname);
            result(req, res, next);
        }
        else {
            res.json(result);
        }
    });
}
exports.mockerHandle = mockerHandle;
//# sourceMappingURL=mockerHandle.js.map